Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2918)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2920)
@@ -6686,28 +7048,25 @@
     SUBROUTINE radiation_write_svf
 
-
-       IMPLICIT NONE
-
-       INTEGER(iwp)        :: fsvf = 89
-       INTEGER(iwp)        :: i
-
-
-       DO  i = 0, io_blocks-1
-          IF ( i == io_group )  THEN
-            
+        IMPLICIT NONE
+        INTEGER(iwp)        :: fsvf = 89
+        INTEGER(iwp)        :: i
+
+        DO  i = 0, io_blocks-1
+            IF ( i == io_group )  THEN
 !
 !--          Open binary file 
              CALL check_open( fsvf )
 
-             WRITE ( fsvf )  usm_version
-             WRITE ( fsvf )  nsvfl, ncsfl
-             WRITE ( fsvf )  svf
-             WRITE ( fsvf )  svfsurf
-             IF ( plant_canopy )  THEN
-                WRITE ( fsvf )  csf
-                WRITE ( fsvf )  csfsurf
-             ENDIF
-             WRITE ( fsvf )  TRIM(svf_code)
-
+                WRITE ( fsvf )  rad_version
+                WRITE ( fsvf )  nsvfl, ncsfl, nsurfl
+                WRITE ( fsvf )  skyvf
+                WRITE ( fsvf )  skyvft
+                WRITE ( fsvf )  svf
+                WRITE ( fsvf )  svfsurf
+                IF ( plant_canopy )  THEN
+                    WRITE ( fsvf )  csf
+                    WRITE ( fsvf )  csfsurf
+                ENDIF
+                WRITE ( fsvf )  TRIM(svf_code)
 !
 !--          Close binary file                 
@@ -6716,11 +7075,250 @@
           ENDIF
 #if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
+                CALL MPI_BARRIER( comm2d, ierr )
 #endif
-       ENDDO
-
+        ENDDO
     END SUBROUTINE radiation_write_svf
 
-
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Block of auxiliary subroutines:
+!> 1. quicksort and corresponding comparison
+!> 2. merge_and_grow_csf for implementation of "dynamical growing"
+!>    array for csf
+!------------------------------------------------------------------------------!
+    PURE FUNCTION svf_lt(svf1,svf2) result (res)
+      TYPE (t_svf), INTENT(in) :: svf1,svf2
+      LOGICAL                  :: res
+      IF ( svf1%isurflt < svf2%isurflt  .OR.    &
+          (svf1%isurflt == svf2%isurflt  .AND.  svf1%isurfs < svf2%isurfs) )  THEN
+          res = .TRUE.
+      ELSE
+          res = .FALSE.
+      ENDIF
+    END FUNCTION svf_lt
+    
+ 
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+    RECURSIVE SUBROUTINE quicksort_svf(svfl, first, last)
+        IMPLICIT NONE
+        TYPE(t_svf), DIMENSION(:), INTENT(INOUT)  :: svfl
+        INTEGER(iwp), INTENT(IN)                  :: first, last
+        TYPE(t_svf)                               :: x, t
+        INTEGER(iwp)                              :: i, j
+
+        IF ( first>=last ) RETURN
+        x = svfl( (first+last) / 2 )
+        i = first
+        j = last
+        DO
+            DO while ( svf_lt(svfl(i),x) )
+               i=i+1
+            ENDDO
+            DO while ( svf_lt(x,svfl(j)) )
+                j=j-1
+            ENDDO
+            IF ( i >= j ) EXIT
+            t = svfl(i);  svfl(i) = svfl(j);  svfl(j) = t
+            i=i+1
+            j=j-1
+        ENDDO
+        IF ( first < i-1 ) CALL quicksort_svf(svfl, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_svf(svfl, j+1, last)
+    END SUBROUTINE quicksort_svf
+
+    
+    PURE FUNCTION csf_lt(csf1,csf2) result (res)
+      TYPE (t_csf), INTENT(in) :: csf1,csf2
+      LOGICAL                  :: res
+      IF ( csf1%ip < csf2%ip  .OR.    &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx < csf2%itx)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity < csf2%ity)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
+            csf1%itz < csf2%itz)  .OR.  &
+           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
+            csf1%itz == csf2%itz  .AND.  csf1%isurfs < csf2%isurfs) )  THEN
+          res = .TRUE.
+      ELSE
+          res = .FALSE.
+      ENDIF
+    END FUNCTION csf_lt
+
+
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+    RECURSIVE SUBROUTINE quicksort_csf(csfl, first, last)
+        IMPLICIT NONE
+        TYPE(t_csf), DIMENSION(:), INTENT(INOUT)  :: csfl
+        INTEGER(iwp), INTENT(IN)                  :: first, last
+        TYPE(t_csf)                               :: x, t
+        INTEGER(iwp)                              :: i, j
+
+        IF ( first>=last ) RETURN
+        x = csfl( (first+last)/2 )
+        i = first
+        j = last
+        DO
+            DO while ( csf_lt(csfl(i),x) )
+                i=i+1
+            ENDDO
+            DO while ( csf_lt(x,csfl(j)) )
+                j=j-1
+            ENDDO
+            IF ( i >= j ) EXIT
+            t = csfl(i);  csfl(i) = csfl(j);  csfl(j) = t
+            i=i+1
+            j=j-1
+        ENDDO
+        IF ( first < i-1 ) CALL quicksort_csf(csfl, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_csf(csfl, j+1, last)
+    END SUBROUTINE quicksort_csf
+
+    
+    SUBROUTINE merge_and_grow_csf(newsize)
+        INTEGER(iwp), INTENT(in)                :: newsize  !< new array size after grow, must be >= ncsfl
+                                                            !< or -1 to shrink to minimum
+        INTEGER(iwp)                            :: iread, iwrite
+        TYPE(t_csf), DIMENSION(:), POINTER      :: acsfnew
+        CHARACTER(100)                          :: msg
+
+        IF ( newsize == -1 )  THEN
+!--         merge in-place
+            acsfnew => acsf
+        ELSE
+!--         allocate new array
+            IF ( mcsf == 0 )  THEN
+                ALLOCATE( acsf1(newsize) )
+                acsfnew => acsf1
+            ELSE
+                ALLOCATE( acsf2(newsize) )
+                acsfnew => acsf2
+            ENDIF
+        ENDIF
+
+        IF ( ncsfl >= 1 )  THEN
+!--         sort csf in place (quicksort)
+            CALL quicksort_csf(acsf,1,ncsfl)
+
+!--         while moving to a new array, aggregate canopy sink factor records with identical box & source
+            acsfnew(1) = acsf(1)
+            iwrite = 1
+            DO iread = 2, ncsfl
+!--             here acsf(kcsf) already has values from acsf(icsf)
+                IF ( acsfnew(iwrite)%itx == acsf(iread)%itx &
+                         .AND.  acsfnew(iwrite)%ity == acsf(iread)%ity &
+                         .AND.  acsfnew(iwrite)%itz == acsf(iread)%itz &
+                         .AND.  acsfnew(iwrite)%isurfs == acsf(iread)%isurfs )  THEN
+!--                 We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
+!--                 probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
+!--                 might mean that the traced beam passes longer through the canopy box.
+                    IF ( acsfnew(iwrite)%rsvf < acsf(iread)%rsvf )  THEN
+                        acsfnew(iwrite)%rtransp = acsf(iread)%rtransp
+                    ENDIF
+                    acsfnew(iwrite)%rsvf = acsfnew(iwrite)%rsvf + acsf(iread)%rsvf
+!--                 advance reading index, keep writing index
+                ELSE
+!--                 not identical, just advance and copy
+                    iwrite = iwrite + 1
+                    acsfnew(iwrite) = acsf(iread)
+                ENDIF
+            ENDDO
+            ncsfl = iwrite
+        ENDIF
+
+        IF ( newsize == -1 )  THEN
+!--         allocate new array and copy shrinked data
+            IF ( mcsf == 0 )  THEN
+                ALLOCATE( acsf1(ncsfl) )
+                acsf1(1:ncsfl) = acsf2(1:ncsfl)
+            ELSE
+                ALLOCATE( acsf2(ncsfl) )
+                acsf2(1:ncsfl) = acsf1(1:ncsfl)
+            ENDIF
+        ENDIF
+
+!--     deallocate old array
+        IF ( mcsf == 0 )  THEN
+            mcsf = 1
+            acsf => acsf1
+            DEALLOCATE( acsf2 )
+        ELSE
+            mcsf = 0
+            acsf => acsf2
+            DEALLOCATE( acsf1 )
+        ENDIF
+        ncsfla = newsize
+
+!         WRITE(msg,'(A,2I12)') 'Grow acsf2:',ncsfl,ncsfla
+!         CALL radiation_write_debug_log( msg )
+
+    END SUBROUTINE merge_and_grow_csf
+
+    
+!-- quicksort.f -*-f90-*-
+!-- Author: t-nissie, adaptation J.Resler
+!-- License: GPLv3
+!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
+    RECURSIVE SUBROUTINE quicksort_csf2(kpcsflt, pcsflt, first, last)
+        IMPLICIT NONE
+        INTEGER(iwp), DIMENSION(:,:), INTENT(INOUT)  :: kpcsflt
+        REAL(wp), DIMENSION(:,:), INTENT(INOUT)      :: pcsflt
+        INTEGER(iwp), INTENT(IN)                     :: first, last
+        REAL(wp), DIMENSION(ndcsf)                   :: t2
+        INTEGER(iwp), DIMENSION(kdcsf)               :: x, t1
+        INTEGER(iwp)                                 :: i, j
+
+        IF ( first>=last ) RETURN
+        x = kpcsflt(:, (first+last)/2 )
+        i = first
+        j = last
+        DO
+            DO while ( csf_lt2(kpcsflt(:,i),x) )
+                i=i+1
+            ENDDO
+            DO while ( csf_lt2(x,kpcsflt(:,j)) )
+                j=j-1
+            ENDDO
+            IF ( i >= j ) EXIT
+            t1 = kpcsflt(:,i);  kpcsflt(:,i) = kpcsflt(:,j);  kpcsflt(:,j) = t1
+            t2 = pcsflt(:,i);  pcsflt(:,i) = pcsflt(:,j);  pcsflt(:,j) = t2
+            i=i+1
+            j=j-1
+        ENDDO
+        IF ( first < i-1 ) CALL quicksort_csf2(kpcsflt, pcsflt, first, i-1)
+        IF ( j+1 < last )  CALL quicksort_csf2(kpcsflt, pcsflt, j+1, last)
+    END SUBROUTINE quicksort_csf2
+    
+
+    PURE FUNCTION csf_lt2(item1, item2) result(res)
+        INTEGER(iwp), DIMENSION(kdcsf), INTENT(in)  :: item1, item2
+        LOGICAL                                     :: res
+        res = ( (item1(3) < item2(3))                                                        &
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) < item2(2))                            &
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) < item2(1)) &
+             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) == item2(1) &
+                 .AND.  item1(4) < item2(4)) )
+    END FUNCTION csf_lt2
+
+    PURE FUNCTION searchsorted(athresh, val) result(ind)
+        REAL(wp), DIMENSION(:), INTENT(IN)  :: athresh
+        REAL(wp), INTENT(IN)                :: val
+        INTEGER(iwp)                        :: ind
+        INTEGER(iwp)                        :: i
+
+        DO i = LBOUND(athresh, 1), UBOUND(athresh, 1)
+            IF ( val < athresh(i) ) THEN
+                ind = i - 1
+                RETURN
+            ENDIF
+        ENDDO
+        ind = UBOUND(athresh, 1)
+    END FUNCTION searchsorted
 
 !------------------------------------------------------------------------------!
@@ -6796,25 +7394,25 @@
                   swd_gridbox(1) = surfinswdif(l)
 
-               CASE (isky,idown_a)                         !- gridbox down_facing face
+               CASE (idown_a)                         !- gridbox down_facing face
                   sw_gridbox(2) = surfinsw(l)
                   lw_gridbox(2) = surfinlw(l)
                   swd_gridbox(2) = surfinswdif(l)
 
-               CASE (inorth_u,inorth_l,inorth_a,isouth_b)  !- gridbox north_facing face
+               CASE (inorth_u,inorth_l,inorth_a)  !- gridbox north_facing face
                   sw_gridbox(3) = surfinsw(l)
                   lw_gridbox(3) = surfinlw(l)
                   swd_gridbox(3) = surfinswdif(l)
 
-               CASE (isouth_u,isouth_l,isouth_a,inorth_b)  !- gridbox south_facing face
+               CASE (isouth_u,isouth_l,isouth_a)  !- gridbox south_facing face
                   sw_gridbox(4) = surfinsw(l)
                   lw_gridbox(4) = surfinlw(l)
                   swd_gridbox(4) = surfinswdif(l)
 
-               CASE (ieast_u,ieast_l,ieast_a,iwest_b)      !- gridbox east_facing face
+               CASE (ieast_u,ieast_l,ieast_a)      !- gridbox east_facing face
                   sw_gridbox(5) = surfinsw(l)
                   lw_gridbox(5) = surfinlw(l)
                   swd_gridbox(5) = surfinswdif(l)
 
-               CASE (iwest_u,iwest_l,iwest_a,ieast_b)      !- gridbox west_facing face
+               CASE (iwest_u,iwest_l,iwest_a)      !- gridbox west_facing face
                   sw_gridbox(6) = surfinsw(l)
                   lw_gridbox(6) = surfinlw(l)
@@ -6841,227 +7439,4 @@
         
     END SUBROUTINE radiation_radflux_gridbox
-
-
-!------------------------------------------------------------------------------!
-!
-! Description:
-! ------------
-!> Block of auxiliary subroutines:
-!> 1. quicksort and corresponding comparison
-!> 2. merge_and_grow_csf for implementation of "dynamical growing"
-!>    array for csf
-!------------------------------------------------------------------------------!    
-    PURE FUNCTION svf_lt(svf1,svf2) result (res)
-      TYPE (t_svf), INTENT(in) :: svf1,svf2
-      LOGICAL                  :: res
-      IF ( svf1%isurflt < svf2%isurflt  .OR.    &
-          (svf1%isurflt == svf2%isurflt  .AND.  svf1%isurfs < svf2%isurfs) )  THEN
-          res = .TRUE.
-      ELSE
-          res = .FALSE.
-      ENDIF
-    END FUNCTION svf_lt
-    
- 
-!-- quicksort.f -*-f90-*-
-!-- Author: t-nissie, adaptation J.Resler
-!-- License: GPLv3
-!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
-    RECURSIVE SUBROUTINE quicksort_svf(svfl, first, last)
-        IMPLICIT NONE
-        TYPE(t_svf), DIMENSION(:), INTENT(INOUT)  :: svfl
-        INTEGER(iwp), INTENT(IN)                  :: first, last
-        TYPE(t_svf)                               :: x, t
-        INTEGER(iwp)                              :: i, j
-
-        IF ( first>=last ) RETURN
-        x = svfl( (first+last) / 2 )
-        i = first
-        j = last
-        DO
-            DO while ( svf_lt(svfl(i),x) )
-                i=i+1
-            ENDDO
-            DO while ( svf_lt(x,svfl(j)) )
-                j=j-1
-            ENDDO
-            IF ( i >= j ) EXIT
-            t = svfl(i);  svfl(i) = svfl(j);  svfl(j) = t
-            i=i+1
-            j=j-1
-        ENDDO
-        IF ( first < i-1 ) CALL quicksort_svf(svfl, first, i-1)
-        IF ( j+1 < last )  CALL quicksort_svf(svfl, j+1, last)
-    END SUBROUTINE quicksort_svf
-
-    
-    PURE FUNCTION csf_lt(csf1,csf2) result (res)
-      TYPE (t_csf), INTENT(in) :: csf1,csf2
-      LOGICAL                  :: res
-      IF ( csf1%ip < csf2%ip  .OR.    &
-           (csf1%ip == csf2%ip  .AND.  csf1%itx < csf2%itx)  .OR.  &
-           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity < csf2%ity)  .OR.  &
-           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
-            csf1%itz < csf2%itz)  .OR.  &
-           (csf1%ip == csf2%ip  .AND.  csf1%itx == csf2%itx  .AND.  csf1%ity == csf2%ity  .AND.   &
-            csf1%itz == csf2%itz  .AND.  csf1%isurfs < csf2%isurfs) )  THEN
-          res = .TRUE.
-      ELSE
-          res = .FALSE.
-      ENDIF
-    END FUNCTION csf_lt
-
-
-!-- quicksort.f -*-f90-*-
-!-- Author: t-nissie, adaptation J.Resler
-!-- License: GPLv3
-!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
-    RECURSIVE SUBROUTINE quicksort_csf(csfl, first, last)
-        IMPLICIT NONE
-        TYPE(t_csf), DIMENSION(:), INTENT(INOUT)  :: csfl
-        INTEGER(iwp), INTENT(IN)                  :: first, last
-        TYPE(t_csf)                               :: x, t
-        INTEGER(iwp)                              :: i, j
-
-        IF ( first>=last ) RETURN
-        x = csfl( (first+last)/2 )
-        i = first
-        j = last
-        DO
-            DO while ( csf_lt(csfl(i),x) )
-                i=i+1
-            ENDDO
-            DO while ( csf_lt(x,csfl(j)) )
-                j=j-1
-            ENDDO
-            IF ( i >= j ) EXIT
-            t = csfl(i);  csfl(i) = csfl(j);  csfl(j) = t
-            i=i+1
-            j=j-1
-        ENDDO
-        IF ( first < i-1 ) CALL quicksort_csf(csfl, first, i-1)
-        IF ( j+1 < last )  CALL quicksort_csf(csfl, j+1, last)
-    END SUBROUTINE quicksort_csf
-
-    
-    SUBROUTINE merge_and_grow_csf(newsize)
-        INTEGER(iwp), INTENT(in)                :: newsize  !< new array size after grow, must be >= ncsfl
-                                                            !< or -1 to shrink to minimum
-        INTEGER(iwp)                            :: iread, iwrite
-        TYPE(t_csf), DIMENSION(:), POINTER      :: acsfnew
-
-        IF ( newsize == -1 )  THEN
-!--         merge in-place
-            acsfnew => acsf
-        ELSE
-!--         allocate new array
-            IF ( mcsf == 0 )  THEN
-                ALLOCATE( acsf1(newsize) )
-                acsfnew => acsf1
-            ELSE
-                ALLOCATE( acsf2(newsize) )
-                acsfnew => acsf2
-            ENDIF
-        ENDIF
-
-        IF ( ncsfl >= 1 )  THEN
-!--         sort csf in place (quicksort)
-            CALL quicksort_csf(acsf,1,ncsfl)
-
-!--         while moving to a new array, aggregate canopy sink factor records with identical box & source
-            acsfnew(1) = acsf(1)
-            iwrite = 1
-            DO iread = 2, ncsfl
-!--             here acsf(kcsf) already has values from acsf(icsf)
-                IF ( acsfnew(iwrite)%itx == acsf(iread)%itx &
-                         .AND.  acsfnew(iwrite)%ity == acsf(iread)%ity &
-                         .AND.  acsfnew(iwrite)%itz == acsf(iread)%itz &
-                         .AND.  acsfnew(iwrite)%isurfs == acsf(iread)%isurfs )  THEN
-!--                 We could simply take either first or second rtransp, both are valid. As a very simple heuristic about which ray
-!--                 probably passes nearer the center of the target box, we choose DIF from the entry with greater CSF, since that
-!--                 might mean that the traced beam passes longer through the canopy box.
-                    IF ( acsfnew(iwrite)%rsvf < acsf(iread)%rsvf )  THEN
-                        acsfnew(iwrite)%rtransp = acsf(iread)%rtransp
-                    ENDIF
-                    acsfnew(iwrite)%rsvf = acsfnew(iwrite)%rsvf + acsf(iread)%rsvf
-!--                 advance reading index, keep writing index
-                ELSE
-!--                 not identical, just advance and copy
-                    iwrite = iwrite + 1
-                    acsfnew(iwrite) = acsf(iread)
-                ENDIF
-            ENDDO
-            ncsfl = iwrite
-        ENDIF
-
-        IF ( newsize == -1 )  THEN
-!--         allocate new array and copy shrinked data
-            IF ( mcsf == 0 )  THEN
-                ALLOCATE( acsf1(ncsfl) )
-                acsf1(1:ncsfl) = acsf2(1:ncsfl)
-            ELSE
-                ALLOCATE( acsf2(ncsfl) )
-                acsf2(1:ncsfl) = acsf1(1:ncsfl)
-            ENDIF
-        ENDIF
-
-!--     deallocate old array
-        IF ( mcsf == 0 )  THEN
-            mcsf = 1
-            acsf => acsf1
-            DEALLOCATE( acsf2 )
-        ELSE
-            mcsf = 0
-            acsf => acsf2
-            DEALLOCATE( acsf1 )
-        ENDIF
-        ncsfla = newsize
-    END SUBROUTINE merge_and_grow_csf
-
-    
-!-- quicksort.f -*-f90-*-
-!-- Author: t-nissie, adaptation J.Resler
-!-- License: GPLv3
-!-- Gist: https://gist.github.com/t-nissie/479f0f16966925fa29ea
-    RECURSIVE SUBROUTINE quicksort_csf2(kpcsflt, pcsflt, first, last)
-        IMPLICIT NONE
-        INTEGER(iwp), DIMENSION(:,:), INTENT(INOUT)  :: kpcsflt
-        REAL(wp), DIMENSION(:,:), INTENT(INOUT)      :: pcsflt
-        INTEGER(iwp), INTENT(IN)                     :: first, last
-        REAL(wp), DIMENSION(ndcsf)                   :: t2
-        INTEGER(iwp), DIMENSION(kdcsf)               :: x, t1
-        INTEGER(iwp)                                 :: i, j
-
-        IF ( first>=last ) RETURN
-        x = kpcsflt(:, (first+last)/2 )
-        i = first
-        j = last
-        DO
-            DO while ( csf_lt2(kpcsflt(:,i),x) )
-                i=i+1
-            ENDDO
-            DO while ( csf_lt2(x,kpcsflt(:,j)) )
-                j=j-1
-            ENDDO
-            IF ( i >= j ) EXIT
-            t1 = kpcsflt(:,i);  kpcsflt(:,i) = kpcsflt(:,j);  kpcsflt(:,j) = t1
-            t2 = pcsflt(:,i);  pcsflt(:,i) = pcsflt(:,j);  pcsflt(:,j) = t2
-            i=i+1
-            j=j-1
-        ENDDO
-        IF ( first < i-1 ) CALL quicksort_csf2(kpcsflt, pcsflt, first, i-1)
-        IF ( j+1 < last )  CALL quicksort_csf2(kpcsflt, pcsflt, j+1, last)
-    END SUBROUTINE quicksort_csf2
-    
-
-    PURE FUNCTION csf_lt2(item1, item2) result(res)
-        INTEGER(iwp), DIMENSION(kdcsf), INTENT(in)  :: item1, item2
-        LOGICAL                                     :: res
-        res = ( (item1(3) < item2(3))                                                        &
-             .OR.  (item1(3) == item2(3)  .AND.  item1(2) < item2(2))                            &
-             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) < item2(1)) &
-             .OR.  (item1(3) == item2(3)  .AND.  item1(2) == item2(2)  .AND.  item1(1) == item2(1) &
-                 .AND.  item1(4) < item2(4)) )
-    END FUNCTION csf_lt2
 
 !------------------------------------------------------------------------------!
@@ -8055,8 +8430,7 @@
 
 !------------------------------------------------------------------------------!
-!
 ! Description:
 ! ------------
-!> Subroutine writes the respective restart data
+!> Subroutine writes local (subdomain) restart data
 !------------------------------------------------------------------------------!
  SUBROUTINE radiation_wrd_local
@@ -8154,6 +8528,10 @@
  END SUBROUTINE radiation_wrd_local
 
-
-SUBROUTINE radiation_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,     &
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Subroutine reads local (subdomain) restart data
+!------------------------------------------------------------------------------!
+ SUBROUTINE radiation_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,    &
                                 nxr_on_file, nynf, nync, nyn_on_file, nysf,    &
                                 nysc, nys_on_file, tmp_2d, tmp_3d, found )
